<?php
class How_to_do_it_right_URL_Rewriting_Admin {
	var $parent = null;
	var $page_name = '';
	function How_to_do_it_right_URL_Rewriting_Admin($parent) {
		$this->parent = $parent;
		$this->page_name = add_menu_page( 'Products', 'Products', 'administrator', 'products', array(&$this, '_menu') );
	}
	function _menu() {
		echo '<div class="wrap">';
		screen_icon('page');
		echo '<h2>Products</h2>';
		
		if ( isset($_POST['action']) )
			$this->_post();
		
		echo '<h3>Current Products</h3>';
			$this->_list();
		echo '<h3>Add Product</h3>';
			$this->_add();
		echo '</div>';
	}
	
	function _list() {
		global $posts, $post;
		$posts = get_posts( array('numberposts' => 0, 'post_type' => 'product') );
		echo '<form method="post" action="admin.php?page=products">';
		echo '<ul>';
		foreach ( $posts as $post ) {
			setup_postdata($post);
			echo '<li>';
				echo '<input type="checkbox" name="products[]" value="' . $post->ID . '" />&nbsp;';
				echo '<a href="' . get_permalink() . '">';
					the_title();
				echo '</a>';
			echo '</li>';
		}
		echo '</ul>';
		echo '<input type="hidden" name="action" value="delete" />';
		wp_nonce_field('delete-products');
		echo '<input type="submit" name="delete" value="Delete All checked" />';
		echo '</form>';
	}
	function _add() {
		echo '<form method="post" action="admin.php?page=products">';
		echo '<ul>';
			echo '<li>';
				echo 'Slug: <input type="text" name="product[post_name]" value="" />';
			echo '</li>';
			echo '<li>';
				echo 'Title: <input type="text" name="product[post_title]" value="" />';
			echo '</li>';
			echo '<li>';
				echo 'Content: <input type="text" name="product[post_content]" value="" />';
			echo '</li>';
		echo '</ul>';
		echo '<input type="hidden" name="action" value="add" />';
		wp_nonce_field('add-product');
		echo '<input type="submit" name="add" value="Add Product" />';
		echo '</form>';
	}
	function _post() {
		switch ( $_REQUEST['action'] ) {
			case 'delete':
				if ( empty($_REQUEST['products']) )
					return;
				check_admin_referer('delete-products');
				foreach ( $_REQUEST['products'] as $id )
					wp_delete_post($id);
				echo '<div class="updated"><p>' . count($_REQUEST['products']) . ' Products deleted.</p></div>';
				break;
			case 'add':
				check_admin_referer('add-product');
				
				$result = wp_insert_post( array_merge( array('post_type' => 'product', 'post_status' => 'publish'), $_REQUEST['product']) );
				var_dump($result);
				
				echo '<div class="updated"><p>Product added.</p></div>';
			break;
		}
	}
}